function randLetter(length) {
    let result = '';
    const characters = 'abcdefghjklmnopqrstuvwxyz';
    const charactersLength = characters.length;
    let counter = 0;
    while (counter < length) {
        result += characters.charAt(Math.floor(Math.random() * charactersLength));
        counter += 1;
    }
    return result;
}

function createId(x, y) {
    return String(x) + ':' + String(y);
}

$(function() {
    var screenH = window.innerHeight;
    var screenW = window.innerWidth;
    var unitH = $('body').css('line-height').slice(0, -2);
    var unitW = $("span").css('width').slice(0, -2);
    var cols = screenW / unitW -1;
    var rows = Math.floor(screenH / unitH)-5;

    var cells = {};

    var scale = 0;
    function shape(type, ox, oy, scale) {
        result = [];
        base= scale - Math.round(scale/2)
        switch (type) {
            case('square'):
                for(x=0; x<scale; x++) {
                    nx = ox - x + base;
                    for (y = 0; y < scale; y++) {
                        ny = oy - y + base;
                        result.push(createId(nx, ny))
                    }
                }
                break;
            case('triangle'):
                for(y = 0; y<scale; y++) {
                    for(x = 0; x<y+1; x++) {
                        ny = oy + y - base;
                        nx = ox + x;
                        nx2 = ox - x;
                        result.push(createId(nx, ny))
                        result.push(createId(nx2, ny))
                    }
                }
                break;
            case('triangleOL'):
                for(y = 0; y < scale; y ++) {
                    if(y === scale - 1) {
                        for(x = 0; x < y; x++) {
                            ny = oy + y - base;
                            nx = ox + x;
                            nx2 = ox - x;
                            result.push(createId(nx, ny))
                            result.push(createId(nx2, ny))
                        }
                    } else {
                        ny = oy + y - base;
                        nx = ox + y;
                        nx2 = ox - y;
                        result.push(createId(nx, ny))
                        result.push(createId(nx2, ny))
                    }
                }
                break;
            case('diamondOL'):
                for(y = 0; y<scale; y ++) {
                    ny = oy + y - scale;
                    ny2 = oy - y + scale;
                    nx = ox + y;
                    nx2 = ox - y;
                    result.push(createId(nx, ny))
                    result.push(createId(nx2, ny))
                    result.push(createId(nx, ny2))
                    result.push(createId(nx2, ny2))
                }
                break;
            case('cross'):
                for(y = 0; y<scale; y ++) {
                    ny = oy + y;
                    ny2 = oy - y;
                    nx = ox + y;
                    nx2 = ox - y;
                    result.push(createId(nx, ny))
                    result.push(createId(nx2, ny))
                    result.push(createId(nx, ny2))
                    result.push(createId(nx2, ny2))
                }
                break;
            case('line'):
                for(x = 0; x<scale; x ++) {
                    result.push(createId(ox - x + base, oy))
                }
                break;
            case('lattice'):
                for(y = 0; y<scale; y ++) {
                    ny = oy + y - base;
                    ny2 = oy - y + base;
                    nx = ox + y;
                    nx2 = ox - y;
                    result.push(createId(nx, ny))
                    result.push(createId(nx2, ny))
                    result.push(createId(nx, ny2))
                    result.push(createId(nx2, ny2))
                }
                break;
        }
        return result;
    }

    var shapeCord = [];
    var isspawn = false;
    var israndom = true;
    var everywhere = false;

    function draw() {
        $('span').each(function(i, el) {
            isspawn = false;
            for(i=0; i<shapeCord.length; i++) {
                if(el.id === shapeCord[i]) {
              //      toss = Math.floor(Math.random()*3)
                    toss = israndom ? Math.floor(Math.random()*10) : 1;
                    if(toss === 1) {
                        isspawn = true;
                    }
                }
            }

            if(everywhere) {
                toss = Math.floor(Math.random() * 1000);
                if (toss === 1) {
                    isspawn = true;
                }
            }

            if(isspawn === true) {
                $(this).html('i').addClass('live').attr('data-next', '1')
                cells[el.id] = 1;
            } else {
                if($(this).attr('data-next') === '1') {
                    $(this).html('i').addClass('live')
                    cells[el.id] = 1;
                }else if($(this).attr('data-next') === '0') {
                   /* if($(this).html()==='i' || $(this).html()==='I' || Math.floor(Math.random()*5) === 1) {
                    }*/
                    $(this).html(randLetter(1)).removeClass('live')

                    cells[el.id] = 0;
                }
            }
        })
    }

    function checkRules(obj) {
        pos = obj.attr('id').split(':');
        x = parseInt(pos[0]);
        y = parseInt(pos[1]);
        adj = [createId(x-1, y-1), createId(x, y-1), createId(x+1, y-1), createId(x-1, y), createId(x+1, y), createId(x-1, y+1), createId(x, y+1), createId(x+1, y+1)];
        total = 0;
        for(i=0; i<adj.length; i++) {
            if(cells[adj[i]]) {
                if(cells[adj[i]] === 1) {
                    total++;
                }
            }
        }

        if(obj.hasClass('live')) {
            if(total<2) {
                obj.attr('data-next', '0');
                cells[obj.id] = 0;
            } else if(total>3) {
                obj.attr('data-next', '0');
                cells[obj.id] = 0;
            } else {
                obj.attr('data-next', '1');
                cells[obj.id] = 1;
            }
        }else {
            if(total === 3) {
                obj.attr('data-next', '1');
                cells[obj.id] = 1;
            } else {
                obj.attr('data-next', '0');
                cells[obj.id] = 0;
            }
        }

    }

    function createField() {
        result = '';
        for(i=0; i<rows; i++) {
            for(l=0; l<cols; l++) {
                id = createId(l, i)
                cells[id] = 0;
                result += "<span id='" + id + "' data-next='0'>" + randLetter(1) + "</span>"
            }
        }
        return result;
    }

    $('body').on('keypress', function(event) {
        console.log(event.which)
        switch (event.which) {
            case(116):
                shapeCord = shape('triangle', Math.floor(cols/2), Math.floor(rows/2), 11)
                break;
            case(115):
                shapeCord = shape('square', Math.floor(cols/2), Math.floor(rows/2), 11)
                break;
            case(108):
                shapeCord = shape('line', Math.floor(cols/2), Math.floor(rows/2), 20)
                break;
            case(100):
                shapeCord = shape('diamondOL', Math.floor(cols/2), Math.floor(rows/2), 11)
                break;
            case(99):
                shapeCord = shape('cross', Math.floor(cols/2), Math.floor(rows/2), 11)
                break;
            case(111):
                shapeCord = shape('triangleOL', Math.floor(cols/2), Math.floor(rows/2), 11)
                break;
            case(97):
                shapeCord = shape('lattice', Math.floor(cols/2), Math.floor(rows/2), 11)
                break;
            case(83):
                israndom = true;
                shapeCord = shape('square', Math.floor(cols/2), Math.floor(rows/2), 20)
                break;
        }
    }).on('keyup', function() {
        shapeCord = [];
  //      israndom = false;
    })

    function step() {
        $('span').each(function() {
            checkRules($(this))
        })
        draw()
        window.requestAnimationFrame(step)
    }

    var seconds = 0;

    $("#start-page").on('click', function() {
        step();
        $('#ants').get(0).play()
        $(this).fadeOut()
        setInterval(function() {
            switch(seconds) {
                case(4):
                    everywhere = true;
                    break;
                case(10):
                    shapeCord = shape('cross', Math.floor(cols/2), Math.floor(rows/2), 11)
                    break;
                case(90):
                    everywhere = false;
                    shape('square', Math.floor(cols/2), Math.floor(rows/2), 11)

            }
            seconds++
        }, 1000)
    })

    $("#main-container").html(createField())



  /*  setTimeout(function() {
        step()
    },500)

     */

})