function randLetter(length) {
    let result = '';
    const characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789ABCDEFGHJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789ABCDEFGHJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789ABCDEFGHJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    const charactersLength = characters.length;
    let counter = 0;
    while (counter < length) {
        result += characters.charAt(Math.floor(Math.random() * charactersLength));
        counter += 1;
    }
    return result;
}
/*function lerp(a, b, p) {
    return (b-a)*p + a;
}*/

$(function() {
    var canvas = document.getElementById("scratch");

    // canvas dimensions
/*    var width = parseInt(canvas.style.width);
    var height = parseInt(canvas.style.height);
*/
    var width = window.innerWidth;
    var height = window.innerHeight;

    // retina
    var dpr = window.devicePixelRatio || 3;
    canvas.width = width*dpr;
    canvas.height = height*dpr;
    canvas.getContext("2d").scale(dpr, dpr);

    // simulation
    var sim = new VerletJS(width, height, canvas);
    sim.friction = 0.9;
    sim.gravity = new Vec2(0,0.05)
    sim.highlightColor = "#fff";

    // entities
  //  var min = Math.min(width,height);
    var segments = 70;
    var pinMod = 1;
    var cloth = sim.cloth(new Vec2(width/2,height/2), width, height, segments, 1, 0.3);
    var anchor = new sim.Composite();
    anchor.particles.push(new Particle(new Vec2(width/2, height/2)))
    anchor.pin(0)
  /*  for (x=0;x<segments;++x) {
        if (x%pinMod == 0)
            cloth.pin(cloth.particles.length - x - 1);
    } */

    for (x=0; x<cloth.particles.length; ++x) {
      //  cloth.particles.cooldown = 0;
       // cloth.particles.letter = randLetter(1);
        $("#main-container").append("<span id='"+ x +"' data-cooldown='0'></span>");
    }

    cloth.drawConstraints = function(ctx, composite) {
    /*    var stride = min/segments;
        var x,y;
        for (y=1;y<segments;++y) {
            for (x=1;x<segments;++x) {
                ctx.beginPath();

                var i1 = (y-1)*segments+x-1;
                var i2 = (y)*segments+x;

                ctx.moveTo(cloth.particles[i1].pos.x, cloth.particles[i1].pos.y);
                ctx.lineTo(cloth.particles[i1+1].pos.x, cloth.particles[i1+1].pos.y);

                ctx.lineTo(cloth.particles[i2].pos.x, cloth.particles[i2].pos.y);
                ctx.lineTo(cloth.particles[i2-1].pos.x, cloth.particles[i2-1].pos.y);

                var off = cloth.particles[i2].pos.x - cloth.particles[i1].pos.x;
                off += cloth.particles[i2].pos.y - cloth.particles[i1].pos.y;
                off *= 0.25;

                var coef = Math.round((Math.abs(off)/stride)*255);
                if (coef > 255)
                    coef = 255;

                ctx.fillStyle = "rgba(" + coef + ",0," + (255-coef)+ "," +lerp(0.25,1,coef/255.0)+")";

                ctx.fill();
            }
        }

        var c;
        for (c in composite.constraints) {
            if (composite.constraints[c] instanceof PinConstraint) {
                var point = composite.constraints[c];
                ctx.beginPath();
                ctx.arc(point.pos.x, point.pos.y, 1.2, 0, 2*Math.PI);
                ctx.fillStyle = "rgba(255,255,255,1)";
                ctx.fill();
            }
        }*/
    }

    cloth.drawParticles = function(ctx, composite) {
        // do nothing for particles
        for (x=0; x<cloth.particles.length; ++x) {

            obj = $("#"+String(x));
            cooldown = parseInt(obj.attr("data-cooldown"));
            if(cooldown>0) {
                cooldown--
                obj.attr("data-cooldown", cooldown);
            } else if(cooldown===0) {
                letter = randLetter(1);
                obj.text(letter).removeClass("I");
                if(letter ==="I") {
                    anchor.constraints.push(new DistanceConstraint(anchor.particles[0], cloth.particles[x], 0.7))
                    obj.attr("data-cooldown", 10).addClass("I");
                }
            }
            obj.css("top", String(cloth.particles[x].pos.y) +"px").css("left", String(cloth.particles[x].pos.x) +"px");
        }
    }

    // animation loop
    var legIndex = 0;
    var loop = function() {
        sim.frame(16);
        sim.draw();

    /*    for (x=0; x<cloth.particles.length; ++x) {
            $("#"+String(x)).text(randLetter(1));
        }*/

        requestAnimFrame(loop);
    };

    loop();


})